=== debian/changelog ===
coreboot (25.09+dfsg-1) unstable; urgency=medium

  * Fix gcc-15 warning unterminated-string-initialization
    (Closes: #1096462)
  * d/control: add missing doc dependency libjs-underscore
  * d/control: Bump standards version
  * New upstream version 25.09+dfsg
  * Refresh patches (gcc-15 fix)
  * d/control: cleanup Rules-Requires-Root
  * d/copyright: Updates for new version

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Sat, 11 Oct 2025 15:25:19 +0100
